KCompletionBox Class Reference

`#include <kcompletionbox.h>`

Inheritance diagram for KCompletionBox:

## Public Slots

QStringList | items () const
void | insertItems (const QStringList &items, int index=-1)
void | setItems (const QStringList &items)
virtual void | popup ()
void | setTabHandling (bool enable)
bool | isTabHandling () const
void | setCancelledText (const QString &txt)
QString | cancelledText () const
void | setActivateOnSelect (bool state)
void | down ()
void | up ()
void | pageDown ()
void | pageUp ()
void | home ()
void | end ()
virtual void | show ()
virtual void | hide ()

## Signals

void | activated (const QString &)
void | userCancelled (const QString &)
Signals inherited from KListBox
void | executed (QListBoxItem *item)
void | executed (QListBoxItem *item, const QPoint &pos)
void | doubleClicked (QListBoxItem *item, const QPoint &pos)

## Public Member Functions

| KCompletionBox (QWidget *parent, const char *name=0)
| ~KCompletionBox ()
virtual QSize | sizeHint () const
bool | activateOnSelect () const
Public Member Functions inherited from KListBox
| KListBox (QWidget *parent=0, const char *name=0, WFlags f=0)

## Protected Slots

virtual void | slotActivated (QListBoxItem *)
Protected Slots inherited from KListBox
void | slotOnItem (QListBoxItem *item)
void | slotOnViewport ()
void | slotSettingsChanged (int)
void | slotAutoSelect ()

## Protected Member Functions

QRect | calculateGeometry () const
void | sizeAndPosition ()
virtual bool | eventFilter (QObject *, QEvent *)
virtual void | virtual_hook (int id, void *data)
Protected Member Functions inherited from KListBox
void | emitExecute (QListBoxItem *item, const QPoint &pos)
virtual void | keyPressEvent (QKeyEvent *e)
virtual void | focusOutEvent (QFocusEvent *fe)
virtual void | leaveEvent (QEvent *e)
virtual void | contentsMousePressEvent (QMouseEvent *e)
virtual void | contentsMouseDoubleClickEvent (QMouseEvent *e)

## Properties

bool | isTabHandling
QString | cancelledText
bool | activateOnSelect

## Additional Inherited Members

Protected Attributes inherited from KListBox
bool | m_bUseSingle
bool | m_bChangeCursorOverItem
QListBoxItem * | m_pCurrentItem
QTimer * | m_pAutoSelect
int | m_autoSelectDelay

## Detailed Description

A helper widget for "completion-widgets" (KLineEdit, KComboBox))

A little utility class for "completion-widgets", like KLineEdit or KComboBox. KCompletionBox is a listbox, displayed as a rectangle without any window decoration, usually directly under the lineedit or combobox. It is filled with all possible matches for a completion, so the user can select the one he wants.

It is used when KGlobalSettings::Completion == CompletionPopup or CompletionPopupAuto.

Author
  Carsten Pfeiffer pfeif.nosp@m.fer@.nosp@m.kde.o.nosp@m.rg

Definition at line 43 of file kcompletionbox.h.

## Constructor & Destructor Documentation

KCompletionBox::KCompletionBox | ( | QWidget * | parent,
|  | const char * | name = `0`
| ) |  |

Constructs a KCompletionBox.

The parent widget is used to give the focus back when pressing the up-button on the very first item.

Definition at line 47 of file kcompletionbox.cpp.

KCompletionBox::~KCompletionBox | ( |  | ) |

Destroys the box.

Definition at line 79 of file kcompletionbox.cpp.

## Member Function Documentation

void KCompletionBox::activated | ( | const QString & |  | ) |

signal

Emitted when an item was selected, contains the text of the selected item.

bool KCompletionBox::activateOnSelect | ( |  | ) | const

Returns
  true if selecting an item results in the emition of the selected signal.

Since
  3.4.1

QRect KCompletionBox::calculateGeometry | ( |  | ) | const

protected

This calculates the size of the dropdown and the relative position of the top left corner with respect to the parent widget.

This matches the geometry and position normally used by K/QComboBox when used with one.

Definition at line 332 of file kcompletionbox.cpp.

QString KCompletionBox::cancelledText | ( |  | ) | const

slot

Returns
  the text set via setCancelledText() or QString::null.

void KCompletionBox::down | ( |  | ) |

slot

Moves the selection one line down or select the first item if nothing is selected yet.

Definition at line 381 of file kcompletionbox.cpp.

void KCompletionBox::end | ( |  | ) |

slot

Moves the selection down to the last item.

Definition at line 421 of file kcompletionbox.cpp.

bool KCompletionBox::eventFilter | ( | QObject * | o,
|  | QEvent * | e
| ) |  |

protected virtual

Reimplemented from KListBox to get events from the viewport (to hide this widget on mouse-click, Escape-presses, etc.

Definition at line 108 of file kcompletionbox.cpp.

void KCompletionBox::hide | ( |  | ) |

virtual slot

Re-implemented for internal reasons.

API is unaffected.

Definition at line 324 of file kcompletionbox.cpp.

void KCompletionBox::home | ( |  | ) |

slot

Moves the selection up to the first item.

Definition at line 416 of file kcompletionbox.cpp.

void KCompletionBox::insertItems | ( | const QStringList & | items,
|  | int | index = `-1`
| ) |  |

slot

Inserts `items` into the box.

Does not clear the items before. `index` determines at which position `items` will be inserted. (defaults to appending them at the end)

Definition at line 468 of file kcompletionbox.cpp.

bool KCompletionBox::isTabHandling | ( |  | ) | const

slot

Returns
  true if this widget is handling Tab-key events to traverse the items in the dropdown list, otherwise false.

Default is false.

See also
  setTabHandling

QStringList KCompletionBox::items | ( |  | ) | const

slot

Returns a list of all items currently in the box.

Definition at line 85 of file kcompletionbox.cpp.

void KCompletionBox::pageDown | ( |  | ) |

slot

Moves the selection one page down.

Definition at line 402 of file kcompletionbox.cpp.

void KCompletionBox::pageUp | ( |  | ) |

slot

Moves the selection one page up.

Definition at line 409 of file kcompletionbox.cpp.

void KCompletionBox::popup | ( |  | ) |

virtual slot

Adjusts the size of the box to fit the width of the parent given in the constructor and pops it up at the most appropriate place, relative to the parent.

Depending on the screensize and the position of the parent, this may be a different place, however the default is to pop it up and the lower left corner of the parent.

Make sure to hide() the box when appropriate.

Definition at line 250 of file kcompletionbox.cpp.

void KCompletionBox::setActivateOnSelect | ( | bool | state | ) |

slot

Set whether or not the selected signal should be emitted when an item is selected.

By default the selected signal is emitted.

Parameters

  state | false if the signal should not be emitted.

Since
  3.4.1

Definition at line 549 of file kcompletionbox.cpp.

void KCompletionBox::setCancelledText | ( | const QString & | txt | ) |

slot

Sets the text to be emitted if the user chooses not to pick from the available matches.

If the canceled text is not set through this function, the userCancelled signal will not be emitted.

See also
  userCancelled( const QString& )

Parameters

  txt | the text to be emitted if the user cancels this box

Definition at line 436 of file kcompletionbox.cpp.

void KCompletionBox::setItems | ( | const QStringList & | items | ) |

slot

Clears the box and inserts `items`.

Definition at line 477 of file kcompletionbox.cpp.

void KCompletionBox::setTabHandling | ( | bool | enable | ) |

slot

Makes this widget (when visible) capture Tab-key events to traverse the items in the dropdown list.

Default off, as it conflicts with the usual behavior of Tab to traverse widgets. It is useful for cases like Konqueror's Location Bar, though.

See also
  isTabHandling

Definition at line 426 of file kcompletionbox.cpp.

void KCompletionBox::show | ( | void |  | ) |

virtual slot

Re-implemented for internal reasons.

API is unaffected.

Definition at line 300 of file kcompletionbox.cpp.

void KCompletionBox::sizeAndPosition | ( |  | ) |

protected

This properly sizes and positions the listbox.

Definition at line 268 of file kcompletionbox.cpp.

void KCompletionBox::slotActivated | ( | QListBoxItem * | item | ) |

protected virtual slot

Called when an item was activated.

Emits activated() with the item.

Definition at line 99 of file kcompletionbox.cpp.

void KCompletionBox::up | ( |  | ) |

slot

Moves the selection one line up or select the first item if nothing is selected yet.

Definition at line 396 of file kcompletionbox.cpp.

void KCompletionBox::userCancelled | ( | const QString & |  | ) |

signal

Emitted whenever the user chooses to ignore the available selections and close the this box.

The documentation for this class was generated from the following files:

- kcompletionbox.h
- kcompletionbox.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys